`timescale 1ns / 1ps
`include "./../MIPI_RefDesign/src/DPHY_TOP.v"    
module MIPI_tb();


   GSR GSR(.GSRI(1'b1));

   reg                      rstn           ;
   reg                      clk            ;
   wire                     MIPI_CLK_P     ;

/*
  initial
  begin
    $fsdbDumpfile("dsi_tx_to_rx.fsdb");
    $fsdbDumpvars;
  end
*/

   initial begin
   clk = 0;
   rstn = 0;
   #1000;
   rstn = 1;
   #100;
   forever #10 clk = ~clk;
   end


   initial begin
   #5_000_000;
   $finish;
   end   


 DPHY_TOP u_DPHY_TOP(
            .clkx2x4          (clk)
			
	 `ifdef HS_CLK 
          ,.HS_CLK_TX_P         (HS_CLK_P)      //HS (High Speed) Clock
          ,.HS_CLK_TX_N         (HS_CLK_N)      //HS (High Speed) Clock
	 `elsif MIPI_CLK
		  ,.MIPI_CLK_TX_P       (MIPI_CLK_P)	 
		  ,.MIPI_CLK_TX_N       (MIPI_CLK_N)
	 `endif  
     `ifdef MIPI_LANE3
          ,.MIPI_LANE3_TX_P       (MIPI_LANE3_P)      //HS (High Speed) Data Lane 3
          ,.MIPI_LANE3_TX_N       (MIPI_LANE3_N)      //HS (High Speed) Data Lane 3
	 `elsif HS_DATA3
          ,.HS_DATA3_TX_P          (HS_LANE3_P)   //HS (High Speed) Data Lane 3
          ,.HS_DATA3_TX_N          (HS_LANE3_N)   //HS (High Speed) Data Lane 3		
	 `endif 
     `ifdef MIPI_LANE2
          ,.MIPI_LANE2_TX_P       (MIPI_LANE2_P)      //HS (High Speed) Data Lane 2
          ,.MIPI_LANE2_TX_N       (MIPI_LANE2_N)      //HS (High Speed) Data Lane 2
	 `elsif HS_DATA2
          ,.HS_DATA2_TX_P          (HS_LANE2_P)   //HS (High Speed) Data Lane 3
          ,.HS_DATA2_TX_N          (HS_LANE2_N)   //HS (High Speed) Data Lane 3			  
     `endif
     `ifdef MIPI_LANE1
          ,.MIPI_LANE1_TX_P       (MIPI_LANE1_P)      //HS (High Speed) Data Lane 1
          ,.MIPI_LANE1_TX_N       (MIPI_LANE1_N)      //HS (High Speed) Data Lane 1
 	 `elsif HS_DATA1
          ,.HS_DATA1_TX_P          (HS_LANE1_P)   //HS (High Speed) Data Lane 3
          ,.HS_DATA1_TX_N          (HS_LANE1_N)   //HS (High Speed) Data Lane 3	    
	 `endif
     `ifdef MIPI_LANE0
          ,.MIPI_LANE0_TX_P       (MIPI_LANE0_P)      //HS (High Speed) Data Lane 0
          ,.MIPI_LANE0_TX_N       (MIPI_LANE0_N)      //HS (High Speed) Data Lane 0
	 `elsif HS_DATA0
          ,.HS_DATA0_TX_P          (HS_LANE0_P)   //HS (High Speed) Data Lane 3
          ,.HS_DATA0_TX_N          (HS_LANE0_N)   //HS (High Speed) Data Lane 3	    
	`endif
	
	
	
	
	
	
	 `ifdef HS_CLK 
          ,.HS_CLK_RX_P         (HS_CLK_P)      //HS (High Speed) Clock
          ,.HS_CLK_RX_N         (HS_CLK_N)      //HS (High Speed) Clock
     `elsif MIPI_CLK
          ,.MIPI_CLK_RX_P       (MIPI_CLK_P)   //HS (High Speed) Clock
          ,.MIPI_CLK_RX_N	   (MIPI_CLK_N) 
     `endif
     `ifdef MIPI_LANE3
          ,.MIPI_LANE3_RX_P       (MIPI_LANE3_P)      //HS (High Speed) Data Lane 3
          ,.MIPI_LANE3_RX_N       (MIPI_LANE3_N)      //HS (High Speed) Data Lane 3
	 `elsif HS_DATA3
          ,.HS_DATA3_RX_P          (HS_LANE3_P)   //HS (High Speed) Data Lane 3
          ,.HS_DATA3_RX_N          (HS_LANE3_N)   //HS (High Speed) Data Lane 3			  
     `endif
     `ifdef MIPI_LANE2
          ,.MIPI_LANE2_RX_P       (MIPI_LANE2_P)      //HS (High Speed) Data Lane 2
          ,.MIPI_LANE2_RX_N       (MIPI_LANE2_N)      //HS (High Speed) Data Lane 2
	 `elsif HS_DATA2
          ,.HS_DATA2_RX_P          (HS_LANE2_P)   //HS (High Speed) Data Lane 3
          ,.HS_DATA2_RX_N          (HS_LANE2_N)   //HS (High Speed) Data Lane 3			  
     `endif		  
     `ifdef MIPI_LANE1
          ,.MIPI_LANE1_RX_P       (MIPI_LANE1_P)      //HS (High Speed) Data Lane 1
          ,.MIPI_LANE1_RX_N       (MIPI_LANE1_N)      //HS (High Speed) Data Lane 1
	 `elsif HS_DATA1
          ,.HS_DATA1_RX_P          (HS_LANE1_P)   //HS (High Speed) Data Lane 3
          ,.HS_DATA1_RX_N          (HS_LANE1_N)   //HS (High Speed) Data Lane 3			  
     `endif
     `ifdef MIPI_LANE0
          ,.MIPI_LANE0_RX_P       (MIPI_LANE0_P)      //HS (High Speed) Data Lane 0
          ,.MIPI_LANE0_RX_N       (MIPI_LANE0_N)      //HS (High Speed) Data Lane 0
	 `elsif HS_DATA0
          ,.HS_DATA0_RX_P          (HS_LANE0_P)   //HS (High Speed) Data Lane 3
          ,.HS_DATA0_RX_N          (HS_LANE0_N)   //HS (High Speed) Data Lane 3			  
     `endif
          ,.hactive_flag     ()
          ,.probe            ()
          ,.ready            ()
        );


endmodule





