`timescale 1ns / 1ps 

////////////////////////////	customized		/////////////////////////////////////////////////

// select data width here ( Single Choice )
// (1)
//`define DATA_WIDTH_BYTE
// (2)
`define DATA_WIDTH_WORD 

///////////////////////////////	end ///////////////////////////////////////////////////

////////////////////////////////	fixed	//////////////////////////////////////////////////
`define gw5at 
`define PLLA

`ifdef DATA_WIDTH_BYTE
	`define GEN_MIPI_TX_8
	`define GEN_MIPI_RX_8
`elsif DATA_WIDTH_WORD
	`define GEN_MIPI_TX_16
	`define GEN_MIPI_RX_16
`endif 

`define MIPI_CLK
`define MIPI_LANE3                               
`define MIPI_LANE2                               
`define MIPI_LANE1                               
`define MIPI_LANE0   

///////////////////////////////// end //////////////////////////////////////////////////////



module DPHY_TOP(
		  input         clkx2x4  
	 `ifdef HS_CLK  
          ,output        HS_CLK_TX_P               //HS (High Speed) Clock
          ,output        HS_CLK_TX_N               //HS (High Speed) Clock
	 `elsif MIPI_CLK
		`ifdef gw5at 
		  ,inout        MIPI_CLK_TX_P  
		  ,inout        MIPI_CLK_TX_N  		
		`else  
		  ,output        MIPI_CLK_TX_P       	 
		  ,output        MIPI_CLK_TX_N  
		`endif
	 `endif 
	 `ifdef HS_DATA3
          ,output        HS_DATA3_TX_P             //HS (High Speed) Data Lane 3
          ,output        HS_DATA3_TX_N             //HS (High Speed) Data Lane 3
	 `elsif MIPI_LANE3
		`ifdef gw5at 
		  ,inout        MIPI_LANE3_TX_P       	 
		  ,inout        MIPI_LANE3_TX_N  		
		`else 	 
		  ,output        MIPI_LANE3_TX_P       	 
		  ,output        MIPI_LANE3_TX_N
		`endif 
	 `endif 		  
     `ifdef HS_DATA2
          ,output        HS_DATA2_TX_P             //HS (High Speed) Data Lane 2
          ,output        HS_DATA2_TX_N             //HS (High Speed) Data Lane 2
	 `elsif MIPI_LANE2
		`ifdef gw5at 
		  ,inout        MIPI_LANE2_TX_P       	 
		  ,inout        MIPI_LANE2_TX_N  		
		`else  	 
		  ,output        MIPI_LANE2_TX_P       	 
		  ,output        MIPI_LANE2_TX_N 
		`endif 
     `endif
     `ifdef HS_DATA1
          ,output        HS_DATA1_TX_P             //HS (High Speed) Data Lane 1
          ,output        HS_DATA1_TX_N             //HS (High Speed) Data Lane 1
	 `elsif MIPI_LANE1
		`ifdef gw5at 
		  ,inout        MIPI_LANE1_TX_P       	 
		  ,inout        MIPI_LANE1_TX_N  		
		`else 	 
		  ,output        MIPI_LANE1_TX_P       	 
		  ,output        MIPI_LANE1_TX_N  
		`endif 
     `endif
     `ifdef HS_DATA0
          ,output        HS_DATA0_TX_P             //HS (High Speed) Data Lane 0
          ,output        HS_DATA0_TX_N             //HS (High Speed) Data Lane 0
	 `elsif MIPI_LANE0
		`ifdef gw5at 
		  ,inout        MIPI_LANE0_TX_P       	 
		  ,inout        MIPI_LANE0_TX_N  		
		`else 	 
		  ,output        MIPI_LANE0_TX_P       	 
		  ,output        MIPI_LANE0_TX_N
		`endif
     `endif
	 `ifdef HS_CLK 
		`ifdef  gw5at
			`ifdef  ELVDS_CLK
				,inout        HS_CLK_RX_P             //HS (High Speed) Clock
				,inout        HS_CLK_RX_N             //HS (High Speed) Clock					
			`else 
				,input        HS_CLK_RX_P             //HS (High Speed) Clock
				,input        HS_CLK_RX_N             //HS (High Speed) Clock						
			`endif 
		`else 
          ,input        HS_CLK_RX_P             //HS (High Speed) Clock
          ,input        HS_CLK_RX_N             //HS (High Speed) Clock
		`endif
     `elsif MIPI_CLK
          ,inout         MIPI_CLK_RX_P             //HS (High Speed) Clock
          ,inout         MIPI_CLK_RX_N	 	    
     `endif     
     `ifdef HS_DATA3
		`ifdef  gw5at
			`ifdef  ELVDS_CLK
				,inout        HS_DATA3_RX_P             //HS (High Speed) Clock
				,inout        HS_DATA3_RX_N             //HS (High Speed) Clock					
			`else 
				,input        HS_DATA3_RX_P             //HS (High Speed) Clock
				,input        HS_DATA3_RX_N             //HS (High Speed) Clock						
			`endif 
		`else 
          ,input        HS_DATA3_RX_P             //HS (High Speed) Clock
          ,input        HS_DATA3_RX_N             //HS (High Speed) Clock
		`endif
     `elsif MIPI_LANE3
          ,inout         MIPI_LANE3_RX_P            //HS (High Speed) Clock
          ,inout         MIPI_LANE3_RX_N	 		     
	 `endif
     `ifdef HS_DATA2
		`ifdef  gw5at
			`ifdef  ELVDS_CLK
				,inout        HS_DATA2_RX_P             //HS (High Speed) Clock
				,inout        HS_DATA2_RX_N             //HS (High Speed) Clock					
			`else 
				,input        HS_DATA2_RX_P             //HS (High Speed) Clock
				,input        HS_DATA2_RX_N             //HS (High Speed) Clock						
			`endif 
		`else 
          ,input        HS_DATA2_RX_P             //HS (High Speed) Clock
          ,input        HS_DATA2_RX_N             //HS (High Speed) Clock
		`endif
     `elsif MIPI_LANE2
          ,inout         MIPI_LANE2_RX_P            //HS (High Speed) Clock
          ,inout         MIPI_LANE2_RX_N	 		     
	 `endif     
     `ifdef HS_DATA1
		`ifdef  gw5at
			`ifdef  ELVDS_CLK
				,inout        HS_DATA1_RX_P             //HS (High Speed) Clock
				,inout        HS_DATA1_RX_N             //HS (High Speed) Clock					
			`else 
				,input        HS_DATA1_RX_P             //HS (High Speed) Clock
				,input        HS_DATA1_RX_N             //HS (High Speed) Clock						
			`endif 
		`else 
          ,input        HS_DATA1_RX_P             //HS (High Speed) Clock
          ,input        HS_DATA1_RX_N             //HS (High Speed) Clock
		`endif
     `elsif MIPI_LANE1
          ,inout         MIPI_LANE1_RX_P            //HS (High Speed) Clock
          ,inout         MIPI_LANE1_RX_N	 		 
     `endif
     `ifdef HS_DATA0
		`ifdef  gw5at
			`ifdef  ELVDS_CLK
				,inout        HS_DATA0_RX_P             //HS (High Speed) Clock
				,inout        HS_DATA0_RX_N             //HS (High Speed) Clock					
			`else 
				,input        HS_DATA0_RX_P             //HS (High Speed) Clock
				,input        HS_DATA0_RX_N             //HS (High Speed) Clock						
			`endif 
		`else 
          ,input        HS_DATA0_RX_P             //HS (High Speed) Clock
          ,input        HS_DATA0_RX_N             //HS (High Speed) Clock
		`endif
     `elsif MIPI_LANE0
          ,inout         MIPI_LANE0_RX_P            //HS (High Speed) Clock
          ,inout         MIPI_LANE0_RX_N	 		 
     `endif
	 

          ,output  reg   hactive_flag     
          ,output  [1:0] probe            
          ,output        ready      
		  	
		  //,output wire [1:0] lp_data0_out_wire 
		  //,output wire hactive_flag_wire 


		  
        );
	wire CLKOUT;
	wire CLKOUTP;

	wire LOCK ;
	assign rstn = LOCK ;
 

 




`ifdef GEN_MIPI_RX_16   
   reg  [63:0] data_in;
   reg  [15:0] data0, data1, data2, data3;
   reg  [15:0] dout, dout1;
   reg  [15:0] data_cntr;
   reg         hactive_flag_RX;

   `ifdef LP_CLK
       wire [1:0]  lp_clk_out;
   `endif
   `ifdef LP_DATA0
       wire [1:0]  lp_data0_out;
   `endif
   `ifdef LP_DATA1
       wire [1:0]  lp_data1_out;
   `endif
   `ifdef LP_DATA2
       wire [1:0]  lp_data2_out;
   `endif
   `ifdef LP_DATA3
       wire [1:0]  lp_data3_out;
   `endif

   wire [15:0] data_out3, data_out2, data_out1, data_out0;
   reg  [63:0] data_out_reg;
   wire        clk_byte_out /* synthesis syn_keep=1 */;
   wire        sclk_tx ;
`endif

`ifdef GEN_MIPI_RX_8   
   reg  [31:0] data_in;
   reg  [7:0]  data0, data1, data2, data3;
   reg  [7:0]  dout, dout1;
   reg  [7:0]  data_cntr;
   reg         hactive_flag_RX;

   `ifdef LP_CLK
       wire [1:0]  lp_clk_out;
   `endif
   `ifdef LP_DATA0
       wire [1:0]  lp_data0_out;
   `endif
   `ifdef LP_DATA1
       wire [1:0]  lp_data1_out;
   `endif
   `ifdef LP_DATA2
       wire [1:0]  lp_data2_out;
   `endif
   `ifdef LP_DATA3
       wire [1:0]  lp_data3_out;
   `endif

   wire [7:0]  data_out3, data_out2, data_out1, data_out0;
   reg  [31:0] data_out_reg;
   wire        clk_byte_out /* synthesis syn_keep=1 */;
   wire        sclk_tx ;
`endif

  wire          lp_clk_dir, lp_data3_dir,lp_data2_dir,lp_data1_dir,lp_data0_dir; 
  wire  [1:0]   lp_clk_in , lp_data3_in, lp_data2_in, lp_data1_in, lp_data0_in;


   reg   [1:0]  hs_en;
   wire  [16:0] dout_rom;
   
///  



/////////////////////////////////////////////////////
// u_plld4 : Used to change the input clock frequency of MIPI DPHY TX

`ifdef GEN_MIPI_TX_8
	`ifdef gw5at
		`ifdef PLLA
			PLLA PLLA_mipi_tx
			(
			.CLKIN 				(clkx2x4),
			.CLKFB              (1'B0),
			.RESET              (1'b0),
			.PLLPWD             (1'B0),
			.RESET_I            (1'B0),
			.RESET_O            (1'B0),
			.PSSEL              (3'B000),
			.PSDIR              (1'B0),
			.PSPULSE            (1'B0),
			.SSCPOL             (1'B0),
			.SSCON              (1'B0),
			.SSCMDSEL      		(7'B0),
			.SSCMDSEL_FRAC 		(3'B0),
			.LOCK               (LOCK),
			.CLKOUT0            (CLKOUT),
			.CLKOUT1            (CLKOUTP),
			.MDCLK              (1'b0),
			.MDOPC         		(2'b00),
			.MDAINC             (1'b0),
			.MDWDI 	    		(8'b0)
			);	
			defparam PLLA_mipi_tx.FCLKIN				  = 	"50"		;
			defparam PLLA_mipi_tx.IDIV_SEL                = 	1			;
			defparam PLLA_mipi_tx.FBDIV_SEL               = 	4			;
			defparam PLLA_mipi_tx.ODIV0_SEL               = 	8			;
			defparam PLLA_mipi_tx.ODIV0_FRAC_SEL          = 	0			;
			defparam PLLA_mipi_tx.ODIV1_SEL               = 	8			;
			defparam PLLA_mipi_tx.MDIV_SEL                = 	5			;
			defparam PLLA_mipi_tx.MDIV_FRAC_SEL           = 	0			;
			defparam PLLA_mipi_tx.CLKOUT0_EN              = 	"TRUE"		;	
			defparam PLLA_mipi_tx.CLKOUT1_EN              = 	"TRUE"		;				
			defparam PLLA_mipi_tx.CLKFB_SEL               = 	"INTERNAL"	;		
			defparam PLLA_mipi_tx.CLKOUT0_DT_DIR          = 	"1'b1"		;	
			defparam PLLA_mipi_tx.CLKOUT1_DT_DIR          = 	"1'b1"		;	
			defparam PLLA_mipi_tx.CLKOUT0_DT_STEP         = 	0			;
			defparam PLLA_mipi_tx.CLKOUT1_DT_STEP         = 	0			;			
			defparam PLLA_mipi_tx.CLK0_IN_SEL             = 	1'b0		;	
			defparam PLLA_mipi_tx.CLK0_OUT_SEL            = 	1'b0		;	
			defparam PLLA_mipi_tx.CLK1_IN_SEL             = 	1'b0		;	
			defparam PLLA_mipi_tx.CLK1_OUT_SEL            = 	1'b0		;	
			defparam PLLA_mipi_tx.DYN_DPA_EN              = 	"FALSE"		;	
			defparam PLLA_mipi_tx.CLKOUT0_PE_COARSE       = 	0		    ;
			defparam PLLA_mipi_tx.CLKOUT0_PE_FINE         = 	0			;
			defparam PLLA_mipi_tx.CLKOUT1_PE_COARSE       = 	2			;
			defparam PLLA_mipi_tx.CLKOUT1_PE_FINE         = 	0			;		
			defparam PLLA_mipi_tx.DYN_PE0_SEL             = 	"FALSE"		;	
			defparam PLLA_mipi_tx.DYN_PE1_SEL             = 	"FALSE"		;		
			defparam PLLA_mipi_tx.DE0_EN                  = 	"FALSE"		;	
			defparam PLLA_mipi_tx.DE1_EN                  = 	"FALSE"		;	
			defparam PLLA_mipi_tx.RESET_I_EN              = 	"FALSE"		;	
			defparam PLLA_mipi_tx.RESET_O_EN              = 	"FALSE"		;			
		`else
         PLL PLL_mipi_tx
         (
              .CLKIN     (clkx2x4    )
			 ,.CLKFB	 (1'b0 	)
             ,.CLKOUT0   (CLKOUT   )
             ,.CLKOUT1   ( CLKOUTP  )
			 ,.RESET(1'b0)
			 ,.PLLPWD(1'b0)
			 ,.RESET_I(1'b0)
			 ,.RESET_O(1'b0)
			 ,.FBDSEL(6'b0)
			 ,.IDSEL(6'b0)
			 ,.MDSEL(6'b0)
			 ,.MDSEL_FRAC(3'b0)
             ,.ODSEL0(7'b0)
			 ,.ODSEL0_FRAC(3'b0)
			 ,.ODSEL1(7'b0)
			 ,.ODSEL2(7'b0)
			 ,.ODSEL3(7'b0)
			 ,.ODSEL4(7'b0)
			 ,.ODSEL5(7'b0)
			 ,.ODSEL6(7'b0)
			 ,.DT0(4'b0)
			 ,.DT1(4'b0)
			 ,.DT2(4'b0)
			 ,.DT3(4'b0)
			 ,.ICPSEL(6'b0)
			 ,.LPFRES(3'b0)
			 ,.LPFCAP(2'b0)
			 ,.PSDIR(1'b0)
			 ,.PSSEL(2'b0)
			 ,.PSPULSE(1'b0)
			 ,.ENCLK0(1'b1)
			 ,.ENCLK1(1'b1)
			 ,.ENCLK2(1'b0)
			 ,.ENCLK3(1'b0)
			 ,.ENCLK4(1'b0)
			 ,.ENCLK5(1'b0)
			 ,.ENCLK6(1'b0)
			 ,.LOCK(LOCK    )
         );
         defparam PLL_mipi_tx.FCLKIN = "50.0" ;
         defparam PLL_mipi_tx.IDIV_SEL = 1   ;
         defparam PLL_mipi_tx.DYN_IDIV_SEL = "FALSE" ;
         defparam PLL_mipi_tx.FBDIV_SEL = 4 ;
         defparam PLL_mipi_tx.DYN_FBDIV_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV0_SEL = 8 ;
         defparam PLL_mipi_tx.ODIV0_FRAC_SEL = 0 ;
         defparam PLL_mipi_tx.DYN_ODIV0_SEL = "FALSE";
         defparam PLL_mipi_tx.ODIV1_SEL = 8 ;
         defparam PLL_mipi_tx.DYN_ODIV1_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV2_SEL = 8 ;
         defparam PLL_mipi_tx.DYN_ODIV2_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV3_SEL = 8 ;
         defparam PLL_mipi_tx.DYN_ODIV3_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV4_SEL = 8 ;
         defparam PLL_mipi_tx.DYN_ODIV4_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV5_SEL = 8 ;
         defparam PLL_mipi_tx.DYN_ODIV5_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV6_SEL = 8 ;
         defparam PLL_mipi_tx.DYN_ODIV6_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_MDIV_SEL = "FALSE" ;
         defparam PLL_mipi_tx.MDIV_SEL = 8 ;
         defparam PLL_mipi_tx.MDIV_FRAC_SEL = 0 ;
         defparam PLL_mipi_tx.CLKOUT0_EN = "TRUE" ;
         defparam PLL_mipi_tx.CLKOUT1_EN = "TRUE" ;
         defparam PLL_mipi_tx.CLKOUT2_EN = "FALSE" ;
         defparam PLL_mipi_tx.CLKOUT3_EN = "FALSE" ;
         defparam PLL_mipi_tx.CLKOUT4_EN = "FALSE" ;
         defparam PLL_mipi_tx.CLKOUT5_EN = "FALSE" ;
         defparam PLL_mipi_tx.CLKOUT6_EN = "FALSE" ;
         defparam PLL_mipi_tx.DYN_DT0_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_DT1_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_DT2_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_DT3_SEL = "FALSE" ;
         defparam PLL_mipi_tx.CLKOUT0_DT_DIR = 1'b1 ;
         defparam PLL_mipi_tx.CLKOUT1_DT_DIR = 1'b1 ;
         defparam PLL_mipi_tx.CLKOUT2_DT_DIR = 1'b1 ;
         defparam PLL_mipi_tx.CLKOUT3_DT_DIR = 1'b1 ;
         defparam PLL_mipi_tx.CLKOUT0_DT_STEP =  0  ;
         defparam PLL_mipi_tx.CLKOUT1_DT_STEP =  0  ;
         defparam PLL_mipi_tx.CLKOUT2_DT_STEP =  0  ;
         defparam PLL_mipi_tx.CLKOUT3_DT_STEP =  0  ;
         defparam PLL_mipi_tx.CLK0_IN_SEL = 1'b0 ;
         defparam PLL_mipi_tx.CLK0_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLK1_IN_SEL = 1'b0 ;
         defparam PLL_mipi_tx.CLK1_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLK2_IN_SEL = 1'b0 ;
         defparam PLL_mipi_tx.CLK2_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLK3_IN_SEL = 1'b0 ;
         defparam PLL_mipi_tx.CLK3_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLK4_IN_SEL = 1'b0 ;
         defparam PLL_mipi_tx.CLK4_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLK5_IN_SEL = 1'b0 ;
         defparam PLL_mipi_tx.CLK5_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLKFB_SEL = "INTERNAL";
         defparam PLL_mipi_tx.DYN_DPA_EN = "FALSE";
         defparam PLL_mipi_tx.CLKOUT0_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT0_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT1_PE_COARSE = 2 ;
         defparam PLL_mipi_tx.CLKOUT1_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT2_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT2_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT3_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT3_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT4_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT4_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT5_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT5_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT6_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT6_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.DYN_PE0_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE1_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE2_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE3_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE4_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE5_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE6_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DE0_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE1_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE2_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE3_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE4_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE5_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE6_EN = "FALSE" ;
         defparam PLL_mipi_tx.RESET_I_EN = "FALSE" ;
         defparam PLL_mipi_tx.RESET_O_EN = "FALSE" ;
         defparam PLL_mipi_tx.DYN_ICP_SEL= "FALSE" ;
         defparam PLL_mipi_tx.ICP_SEL    = 6'bXXXXXX;
         defparam PLL_mipi_tx.DYN_LPF_SEL = "FALSE" ;
         defparam PLL_mipi_tx.LPF_RES    = 3'bXXX;
         defparam PLL_mipi_tx.LPF_CAP    = 2'b00 ;
         defparam PLL_mipi_tx.SSC_EN     = "FALSE" ;
		`endif
	`else 
      rPLL pll_mipi_tx
      (
           .CLKOUT   (CLKOUT                                     )
          ,.LOCK     (LOCK                                       )
          ,.CLKOUTP  (CLKOUTP                                    )
          ,.CLKOUTD  (clkoutd_o                                  )
          ,.CLKOUTD3 (clkoutd3_o                                 )
          ,.RESET    (1'b0                                       )
          ,.RESET_P  (1'b0                                       )
          ,.CLKIN    (clkx2x4                                    )
          ,.CLKFB    (1'b0                                       )
          ,.FBDSEL   (6'd0                                       )
          ,.IDSEL    (6'd0                                       )
          ,.ODSEL    (6'd0                                       )
          ,.PSDA     (4'd0                                       )
          ,.DUTYDA   (4'd0                                       )
          ,.FDLY     (4'hF                                       )
      );
      defparam pll_mipi_tx.FCLKIN="50"; 
      defparam pll_mipi_tx.DYN_IDIV_SEL= "false";
      defparam pll_mipi_tx.IDIV_SEL = 1; 
      defparam pll_mipi_tx.DYN_FBDIV_SEL= "false";
      defparam pll_mipi_tx.FBDIV_SEL = 7; 
      defparam pll_mipi_tx.DYN_ODIV_SEL= "false";
      defparam pll_mipi_tx.ODIV_SEL = 4;
      defparam pll_mipi_tx.PSDA_SEL= "0100";
      defparam pll_mipi_tx.DYN_DA_EN = "false";
      defparam pll_mipi_tx.DUTYDA_SEL= "1000";
      defparam pll_mipi_tx.CLKOUT_FT_DIR = 1'b1;  
      defparam pll_mipi_tx.CLKOUTP_FT_DIR = 1'b1; 
      defparam pll_mipi_tx.CLKFB_SEL = "internal";
      defparam pll_mipi_tx.CLKOUT_BYPASS = "false";  
      defparam pll_mipi_tx.CLKOUTP_BYPASS = "false";   
      defparam pll_mipi_tx.CLKOUTD_BYPASS = "false";  
      defparam pll_mipi_tx.DYN_SDIV_SEL = 2; 
      defparam pll_mipi_tx.CLKOUTD_SRC =  "CLKOUT";  
      defparam pll_mipi_tx.CLKOUTD3_SRC = "CLKOUT"; 
      defparam pll_mipi_tx.DEVICE = "GW1N-9";
	`endif	  
      CLKDIV U3_CLKDIV (.RESETN(rstn), .HCLKIN(CLKOUT), .CALIB(1'b0), .CLKOUT(sclk_tx));
      defparam U3_CLKDIV.DIV_MODE = "4" ;

`endif
`ifdef GEN_MIPI_TX_16
	`ifdef gw5at
		`ifdef PLLA 
			PLLA PLLA_mipi_tx
			(
			.CLKIN 				(clkx2x4),
			.CLKFB              (1'B0),
			.RESET              (1'b0),
			.PLLPWD             (1'B0),
			.RESET_I            (1'B0),
			.RESET_O            (1'B0),
			.PSSEL              (3'B000),
			.PSDIR              (1'B0),
			.PSPULSE            (1'B0),
			.SSCPOL             (1'B0),
			.SSCON              (1'B0),
			.SSCMDSEL      		(7'B0),
			.SSCMDSEL_FRAC 		(3'B0),
			.LOCK               (LOCK),
			.CLKOUT0            (CLKOUT),
			.CLKOUT1            (CLKOUTP),
			.CLKOUT2            (),
			.CLKOUT3            (),
			.CLKOUT4            (),
			.CLKOUT5            (),
			.CLKOUT6            (),
			.CLKFBOUT           (),
			.MDRDO              (),
			.MDCLK              (1'b0),
			.MDOPC         		(2'b00),
			.MDAINC             (1'b0),
			.MDWDI 	    		(8'b0)
			);	
			defparam PLLA_mipi_tx.FCLKIN				  = 	"50"		;
			defparam PLLA_mipi_tx.IDIV_SEL                = 	2			;
			defparam PLLA_mipi_tx.FBDIV_SEL               = 	8			;
			defparam PLLA_mipi_tx.ODIV0_SEL               = 	80			;
			defparam PLLA_mipi_tx.ODIV0_FRAC_SEL          = 	0			;
			defparam PLLA_mipi_tx.ODIV1_SEL               = 	80			;
			defparam PLLA_mipi_tx.MDIV_SEL                = 	4			;
			defparam PLLA_mipi_tx.MDIV_FRAC_SEL           = 	0			;
			defparam PLLA_mipi_tx.CLKOUT0_EN              = 	"TRUE"		;	
			defparam PLLA_mipi_tx.CLKOUT1_EN              = 	"TRUE"		;				
			defparam PLLA_mipi_tx.CLKFB_SEL               = 	"INTERNAL"	;		
			defparam PLLA_mipi_tx.CLKOUT0_DT_DIR          = 	"1'b1"		;	
			defparam PLLA_mipi_tx.CLKOUT1_DT_DIR          = 	"1'b1"		;	
			defparam PLLA_mipi_tx.CLKOUT0_DT_STEP         = 	0			;
			defparam PLLA_mipi_tx.CLKOUT1_DT_STEP         = 	0			;			
			defparam PLLA_mipi_tx.CLK0_IN_SEL             = 	1'b0		;	
			defparam PLLA_mipi_tx.CLK0_OUT_SEL            = 	1'b0		;	
			defparam PLLA_mipi_tx.CLK1_IN_SEL             = 	1'b0		;	
			defparam PLLA_mipi_tx.CLK1_OUT_SEL            = 	1'b0		;	
			defparam PLLA_mipi_tx.DYN_DPA_EN              = 	"FALSE"		;	
			defparam PLLA_mipi_tx.CLKOUT0_PE_COARSE       = 	0		    ;
			defparam PLLA_mipi_tx.CLKOUT0_PE_FINE         = 	0			;
			defparam PLLA_mipi_tx.CLKOUT1_PE_COARSE       = 	20			;
			defparam PLLA_mipi_tx.CLKOUT1_PE_FINE         = 	0			;		
			defparam PLLA_mipi_tx.DYN_PE0_SEL             = 	"FALSE"		;	
			defparam PLLA_mipi_tx.DYN_PE1_SEL             = 	"FALSE"		;		
			defparam PLLA_mipi_tx.DE0_EN                  = 	"FALSE"		;	
			defparam PLLA_mipi_tx.DE1_EN                  = 	"FALSE"		;	
			defparam PLLA_mipi_tx.RESET_I_EN              = 	"FALSE"		;	
			defparam PLLA_mipi_tx.RESET_O_EN              = 	"FALSE"		;						
		`else
         PLL PLL_mipi_tx
         (
              .CLKIN     (clkx2x4    )
			 ,.CLKFB	 (1'b0 	)
             ,.CLKOUT0   (CLKOUT   )
             ,.CLKOUT1   ( CLKOUTP  )
			 ,.RESET(1'B0)
			 ,.PLLPWD(1'b0)
			 ,.RESET_I(1'b0)
			 ,.RESET_O(1'b0)
			 ,.FBDSEL(6'b0)
			 ,.IDSEL(6'b0)
			 ,.MDSEL(7'b0)
			 ,.MDSEL_FRAC(3'b0)
             ,.ODSEL0(7'b0) 
			 ,.ODSEL0_FRAC(3'b0)
			 ,.ODSEL1(7'b0)
			 ,.ODSEL2(7'b0)
			 ,.ODSEL3(7'b0)
			 ,.ODSEL4(7'b0)
			 ,.ODSEL5(7'b0)
			 ,.ODSEL6(7'b0)
			 ,.DT0(4'b0)
			 ,.DT1(4'b0)
			 ,.DT2(4'b0)
			 ,.DT3(4'b0)
			 ,.ICPSEL(6'b0)
			 ,.LPFRES(3'b0)
			 ,.LPFCAP(2'b0)
			 ,.PSDIR(1'b0)
			 ,.PSSEL(3'b0)
			 ,.PSPULSE(1'b0)
			 ,.ENCLK0(1'b1)
			 ,.ENCLK1(1'b1)
			 ,.ENCLK2(1'b0)
			 ,.ENCLK3(1'b0)
			 ,.ENCLK4(1'b0)
			 ,.ENCLK5(1'b0)
			 ,.ENCLK6(1'b0)
			 ,.LOCK(LOCK    )
			 ,.SSCPOL(1'b0)
			 ,.SSCON(1'B0)
			 ,.SSCMDSEL(7'B0)
			 ,.SSCMDSEL_FRAC(3'B0)
         );
         defparam PLL_mipi_tx.FCLKIN = "50.0" ;
         defparam PLL_mipi_tx.IDIV_SEL = 2   ;
         defparam PLL_mipi_tx.DYN_IDIV_SEL = "FALSE" ;
         defparam PLL_mipi_tx.FBDIV_SEL = 8 ;
         defparam PLL_mipi_tx.DYN_FBDIV_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV0_SEL = 4 ;
         defparam PLL_mipi_tx.ODIV0_FRAC_SEL = 0 ;
         defparam PLL_mipi_tx.DYN_ODIV0_SEL = "FALSE";
         defparam PLL_mipi_tx.ODIV1_SEL = 4 ;
         defparam PLL_mipi_tx.DYN_ODIV1_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV2_SEL = 4 ;
         defparam PLL_mipi_tx.DYN_ODIV2_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV3_SEL = 8 ;
         defparam PLL_mipi_tx.DYN_ODIV3_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV4_SEL = 8 ;
         defparam PLL_mipi_tx.DYN_ODIV4_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV5_SEL = 8 ;
         defparam PLL_mipi_tx.DYN_ODIV5_SEL = "FALSE" ;
         defparam PLL_mipi_tx.ODIV6_SEL = 8 ;
         defparam PLL_mipi_tx.DYN_ODIV6_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_MDIV_SEL = "FALSE" ;
         defparam PLL_mipi_tx.MDIV_SEL = 8 ;
         defparam PLL_mipi_tx.MDIV_FRAC_SEL = 0 ;
         defparam PLL_mipi_tx.CLKOUT0_EN = "TRUE" ;
         defparam PLL_mipi_tx.CLKOUT1_EN = "TRUE" ;
         defparam PLL_mipi_tx.CLKOUT2_EN = "FALSE" ;
         defparam PLL_mipi_tx.CLKOUT3_EN = "FALSE" ;
         defparam PLL_mipi_tx.CLKOUT4_EN = "FALSE" ;
         defparam PLL_mipi_tx.CLKOUT5_EN = "FALSE" ;
         defparam PLL_mipi_tx.CLKOUT6_EN = "FALSE" ;
         defparam PLL_mipi_tx.DYN_DT0_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_DT1_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_DT2_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_DT3_SEL = "FALSE" ;
         defparam PLL_mipi_tx.CLKOUT0_DT_DIR = 1'b1 ;
         defparam PLL_mipi_tx.CLKOUT1_DT_DIR = 1'b1 ;
         defparam PLL_mipi_tx.CLKOUT2_DT_DIR = 1'b1 ;
         defparam PLL_mipi_tx.CLKOUT3_DT_DIR = 1'b1 ;
         defparam PLL_mipi_tx.CLKOUT0_DT_STEP =  0  ;
         defparam PLL_mipi_tx.CLKOUT1_DT_STEP =  0  ;
         defparam PLL_mipi_tx.CLKOUT2_DT_STEP =  0  ;
         defparam PLL_mipi_tx.CLKOUT3_DT_STEP =  0  ;
         defparam PLL_mipi_tx.CLK0_IN_SEL = 1'b0 ;
         defparam PLL_mipi_tx.CLK0_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLK1_IN_SEL = 1'b0 ;
         defparam PLL_mipi_tx.CLK1_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLK2_IN_SEL = 1'b0 ;
         defparam PLL_mipi_tx.CLK2_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLK3_IN_SEL = 1'b0 ; 
         defparam PLL_mipi_tx.CLK3_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLK4_IN_SEL = 1'b0 ;
         defparam PLL_mipi_tx.CLK4_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLK5_IN_SEL = 1'b0 ;
         defparam PLL_mipi_tx.CLK5_OUT_SEL= 1'b0 ;
         defparam PLL_mipi_tx.CLKFB_SEL = "INTERNAL"; 
         defparam PLL_mipi_tx.DYN_DPA_EN = "FALSE";
         defparam PLL_mipi_tx.CLKOUT0_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT0_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT1_PE_COARSE = 4 ;
         defparam PLL_mipi_tx.CLKOUT1_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT2_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT2_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT3_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT3_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT4_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT4_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT5_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT5_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.CLKOUT6_PE_COARSE = 0 ;
         defparam PLL_mipi_tx.CLKOUT6_PE_FINE   = 0 ;
         defparam PLL_mipi_tx.DYN_PE0_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE1_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE2_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE3_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE4_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE5_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DYN_PE6_SEL = "FALSE" ;
         defparam PLL_mipi_tx.DE0_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE1_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE2_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE3_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE4_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE5_EN = "FALSE" ;
         defparam PLL_mipi_tx.DE6_EN = "FALSE" ;
         defparam PLL_mipi_tx.RESET_I_EN = "FALSE" ;
         defparam PLL_mipi_tx.RESET_O_EN = "FALSE" ;
         defparam PLL_mipi_tx.DYN_ICP_SEL= "FALSE" ;
         defparam PLL_mipi_tx.ICP_SEL    = 6'bXXXXXX;
         defparam PLL_mipi_tx.DYN_LPF_SEL = "FALSE" ;
         defparam PLL_mipi_tx.LPF_RES    = 3'bXXX;
         defparam PLL_mipi_tx.LPF_CAP    = 2'b00 ;
         defparam PLL_mipi_tx.SSC_EN     = "FALSE" ;
		`endif
	`else
      rPLL pll_mipi_tx
      (
           .CLKOUT   (CLKOUT                                     )
          ,.LOCK     (LOCK                                       )
          ,.CLKOUTP  (CLKOUTP                                    )
          ,.CLKOUTD  (clkoutd_o                                  )
          ,.CLKOUTD3 (clkoutd3_o                                 )
          ,.RESET    (1'b0                                       )
          ,.RESET_P  (1'b0                                       )
          ,.CLKIN    (clkx2x4                                    )
          ,.CLKFB    (1'b0                                       )
          ,.FBDSEL   (6'd0                                       )
          ,.IDSEL    (6'd0                                       )
          ,.ODSEL    (6'd0                                       )
          ,.PSDA     (4'd0                                       )
          ,.DUTYDA   (4'd0                                       )
          ,.FDLY     (4'hF                                       )
      );
      defparam pll_mipi_tx.FCLKIN = "50";
      defparam pll_mipi_tx.DYN_IDIV_SEL = "false";
      defparam pll_mipi_tx.IDIV_SEL = 0;
      defparam pll_mipi_tx.DYN_FBDIV_SEL = "false";
      defparam pll_mipi_tx.FBDIV_SEL = 7;
      defparam pll_mipi_tx.DYN_ODIV_SEL = "false";
      defparam pll_mipi_tx.ODIV_SEL = 2;
      defparam pll_mipi_tx.PSDA_SEL = "0100";
      defparam pll_mipi_tx.DYN_DA_EN = "false";
      defparam pll_mipi_tx.DUTYDA_SEL = "1000";
      defparam pll_mipi_tx.CLKOUT_FT_DIR = 1'b1;
      defparam pll_mipi_tx.CLKOUTP_FT_DIR = 1'b1;
      defparam pll_mipi_tx.CLKOUT_DLY_STEP = 0;
      defparam pll_mipi_tx.CLKOUTP_DLY_STEP = 0;
      defparam pll_mipi_tx.CLKFB_SEL = "internal";
      defparam pll_mipi_tx.CLKOUT_BYPASS = "false";
      defparam pll_mipi_tx.CLKOUTP_BYPASS = "false";
      defparam pll_mipi_tx.CLKOUTD_BYPASS = "false";
      defparam pll_mipi_tx.DYN_SDIV_SEL = 2;
      defparam pll_mipi_tx.CLKOUTD_SRC = "CLKOUT";
      defparam pll_mipi_tx.CLKOUTD3_SRC = "CLKOUT";
      defparam pll_mipi_tx.DEVICE = "GW1N-9";
      defparam U3_CLKDIV.DIV_MODE = "8" ;
	`endif
      CLKDIV U3_CLKDIV (.RESETN(rstn), .HCLKIN(CLKOUT), .CALIB(1'b0), .CLKOUT(sclk_tx));
      defparam U3_CLKDIV.DIV_MODE = "8" ;	
`endif
/////////////////////////////////////////////////////
// Generate HS Data & HS_EN
/////////////////////////////////////////////////////
 wire [1:0] lp_data_out ;
 
    ROM549x17 u_ROM549x17(
     .clk   (sclk_tx),
     .rstn  (rstn),
     .dout  (dout_rom),
	 .lp_data ( lp_data_out ),
	 .lp_dir  (lp_dir)
     );


`ifdef GEN_MIPI_TX_16 
  wire [15:0] clk_data;
  assign clk_data = 16'b0101_0101_0101_0101;
  always @(posedge sclk_tx or negedge rstn)
  begin
       if(~rstn)
         {hactive_flag,dout1} <= 0;
       else
         {hactive_flag,dout1} <= dout_rom;
  end
`endif

`ifdef GEN_MIPI_TX_8 
  always @(posedge sclk_tx or negedge rstn)
  begin
       if(~rstn)
         {hactive_flag,dout1} <= 0;
       else
         {hactive_flag,dout1} <= {dout_rom[16],dout_rom[7:0]};
  end
  wire [7:0] clk_data;
  assign clk_data = 8'b0101_0101;
`endif


wire [1:0] rx_lp_clk_out ;
wire [1:0] rx_lp_data0_out ;
wire [1:0] rx_lp_data1_out ;
wire [1:0] rx_lp_data2_out ;
wire [1:0] rx_lp_data3_out ;



// DPHY_TX_TOP u_MIPI_TX_Advance_Top
  MIPI_TX_Advance_Top u_MIPI_TX_Advance_Top
	
	(
          .reset_n      (rstn)              ,
     `ifdef MIPI_CLK 
		`ifdef gw5at	
			.lp_clk_in		 (lp_clk_in	),
			.lp_clk_dir      (lp_dir),
		`endif 
          .MIPI_CLK_P        (MIPI_CLK_TX_P),      
          .MIPI_CLK_N        (MIPI_CLK_TX_N),      
          .clk_data    	 	 (clk_data) ,
          .lp_clk_out        (2'b11),      
     `elsif HS_CLK
          .HS_CLK_P     (HS_CLK_TX_P)       ,
          .HS_CLK_N     (HS_CLK_TX_N)       ,
          .clk_data     (clk_data   )       ,
     `endif 		  
		  
     `ifdef INTERNAL_PLL
          .clk_byte     (clkx2x4    )       ,
          .sclk         (           )       ,
     `else
          .clk_bit      (CLKOUT     )       ,
          .clk_bit_90   (CLKOUTP    )       ,
          .sclk         (sclk_tx    )       ,
     `endif
    `ifdef MIPI_LANE3
		`ifdef gw5at	
			.lp_data3_in	   (lp_data3_in),
			.lp_data3_dir      (lp_dir),
		`endif 	
          .MIPI_LANE3_P   (MIPI_LANE3_TX_P)  ,     
          .MIPI_LANE3_N   (MIPI_LANE3_TX_N)  ,     
          .data_in3		  (dout1),	     
          .lp_data3_out   (lp_data_out) ,     
     `endif
     `ifdef MIPI_LANE2
		`ifdef gw5at	
			.lp_data2_in	   (lp_data2_in),
			.lp_data2_dir      (lp_dir),
		`endif	 
          .MIPI_LANE2_P     (MIPI_LANE2_TX_P),     
          .MIPI_LANE2_N     (MIPI_LANE2_TX_N),     
          .data_in2 		(dout1),     
          .lp_data2_out     (lp_data_out),     

     `endif
     `ifdef MIPI_LANE1
		`ifdef gw5at	
			.lp_data1_in	   (lp_data1_in),
			.lp_data1_dir      (lp_dir),
		`endif	 
          .MIPI_LANE1_P     (MIPI_LANE1_TX_P),     
          .MIPI_LANE1_N     (MIPI_LANE1_TX_N),     
          .data_in1 		(dout1),     
          .lp_data1_out     (lp_data_out),     

     `endif
     `ifdef MIPI_LANE0
		`ifdef gw5at	
			.lp_data0_in	   (lp_data0_in),
			.lp_data0_dir      (lp_dir),
		`endif	 
          .MIPI_LANE0_P     (MIPI_LANE0_TX_P),     
          .MIPI_LANE0_N     (MIPI_LANE0_TX_N),     
          .data_in0 		(dout1),     
          .lp_data0_out     (lp_data_out),     
     `endif	 
     `ifdef HS_DATA3
          .HS_DATA3_P   (HS_DATA3_TX_P)     ,
          .HS_DATA3_N   (HS_DATA3_TX_N)     ,
          .data_in3     (dout1)             ,
     `endif
     `ifdef HS_DATA2
          .HS_DATA2_P   (HS_DATA2_TX_P)     ,
          .HS_DATA2_N   (HS_DATA2_TX_N)     ,
          .data_in2     (dout1)             ,
     `endif
     `ifdef HS_DATA1
          .HS_DATA1_P   (HS_DATA1_TX_P)     ,
          .HS_DATA1_N   (HS_DATA1_TX_N)     ,
          .data_in1     (dout1)             ,
     `endif
     `ifdef HS_DATA0
          .HS_DATA0_P   (HS_DATA0_TX_P)     ,
          .HS_DATA0_N   (HS_DATA0_TX_N)     ,
          .data_in0     (dout1)             ,
     `endif
          .hs_clk_en    (1'b1)   ,
          .hs_data_en   (hactive_flag)
      );


//    DPHY_RX_TOP u_MIPI_RX_Advance_Top
	MIPI_RX_Advance_Top	 MIPI_RX_Advance_Top 
	(
                .reset_n        (rstn       )   ,
	 `ifdef MIPI_CLK
          .MIPI_CLK_P        (MIPI_CLK_RX_P),   
          .MIPI_CLK_N        (MIPI_CLK_RX_N),   
          .lp_clk_out        (rx_lp_clk_out),  
          .lp_clk_in         (lp_data_out),  
          .lp_clk_dir        (!lp_dir),   
     `elsif HS_CLK
          .HS_CLK_P          (HS_CLK_RX_P), 
          .HS_CLK_N          (HS_CLK_RX_N), 
     `endif

      .clk_byte_out   (clk_byte_out)  ,
	  
     `ifdef HS_DATA3
                .HS_DATA3_P     (HS_DATA3_RX_P) ,
                .HS_DATA3_N     (HS_DATA3_RX_N) ,
                .data_out3      (data_out3)     ,
     `elsif MIPI_LANE3
				.MIPI_LANE3_P     (MIPI_LANE3_RX_P),  
				.MIPI_LANE3_N     (MIPI_LANE3_RX_N),  
				.data_out3		  (data_out3),   	
				.lp_data3_out     (rx_lp_data3_out),   			
				.lp_data3_in      (lp_data_out),   			
				.lp_data3_dir     (!lp_dir),     
	 `endif
     `ifdef HS_DATA2
                .HS_DATA2_P     (HS_DATA2_RX_P) ,
                .HS_DATA2_N     (HS_DATA2_RX_N) ,
                .data_out2      (data_out2)     ,
     `elsif MIPI_LANE2
				.MIPI_LANE2_P     (MIPI_LANE2_RX_P),  	
				.MIPI_LANE2_N     (MIPI_LANE2_RX_N),  	
				.data_out2        (data_out2),   	 
				.lp_data2_out     (rx_lp_data2_out),   	
				.lp_data2_in      (lp_data_out),   	
				.lp_data2_dir     (!lp_dir), 				
     `endif
     `ifdef HS_DATA1
                .HS_DATA1_P     (HS_DATA1_RX_P) ,
                .HS_DATA1_N     (HS_DATA1_RX_N) ,
                .data_out1      (data_out1)     ,
     `elsif MIPI_LANE1
				.MIPI_LANE1_P     (MIPI_LANE1_RX_P ),   
				.MIPI_LANE1_N     (MIPI_LANE1_RX_N ),   
				.data_out1        (data_out1),   
				.lp_data1_out     (rx_lp_data1_out),   
				.lp_data1_in      (lp_data_out),   
				.lp_data1_dir     (!lp_dir), 
	 `endif
     `ifdef HS_DATA0
                .HS_DATA0_P     (HS_DATA0_RX_P) ,
                .HS_DATA0_N     (HS_DATA0_RX_N) ,
                .data_out0      (data_out0)     ,
     `elsif MIPI_LANE0
				.MIPI_LANE0_P     (MIPI_LANE0_RX_P),   
				.MIPI_LANE0_N     (MIPI_LANE0_RX_N),   
				.data_out0        (data_out0),   
				.lp_data0_out     (rx_lp_data0_out),   
				.lp_data0_in      (lp_data_out), 
				.lp_data0_dir     (!lp_dir), 				
     `endif

                .hs_en          (hactive_flag)  ,
                .clk_term_en    (1'b1        )  ,
                .data_term_en   (1'b1        )  ,
                .ready          (ready       )
      );


always @(posedge clk_byte_out or negedge rstn)
  begin
       if(~rstn)
         data_out_reg <= 0;
       else
         data_out_reg <= {data_out3,data_out2,data_out1,data_out0};
  end

assign probe[0] = ^data_out_reg;
assign probe[1] = 1'b0;








endmodule





